#!/usr/bin/python
# -*- coding: utf-8 -*- 
#
#  @Copyright (C) 2008 Kim Jin Chul (shriekout@gmail.com).
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU Library General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#

import sys

def readHTMLSource(url, coding = 'utf-8'):
	import urllib2

	socket = urllib2.urlopen(url)
	htmlSource = socket.read()
	socket.close()

	return unicode(htmlSource, coding).encode('utf-8')

def parsingXMLSource(xmlSource):
	import libxml2

	doc = libxml2.parseDoc(xmlSource)

	child = doc.children

	if child.name == 'error':
		child = child.children
		child = child.next

		if child.content == '000':
			code = '000: System error'
		elif child.content == '010':
			code = '010: Your query request count is over the limit'
		elif child.content == '011':
			code = '011: Incorrect query request'
		elif child.content == '020':
			code = '020: Unregistered key'
		elif child.content == '021':
			code = '021: Your key is temporary unavailable'
		elif child.content == '100':
			code = '100: Invalid target value'
		elif child.content == '101':
			code = '101: Invalid display value'
		elif child.content == '102':
			code = '102: Invalid start value'
		elif child.content == '110':
			code = '110: Undefined sort value'
		elif child.content == '200':
			code = '200: Reserved'
		elif child.content == '900':
			code = '900: Undefined error occured'

		print "Error!\n" + code
		sys.exit(1)

	value = []

	while child.name != 'channel':
		child = child.children

	child = child.children

	while child:
		if child.name == 'total':
			if child.content:
				value.append(child.content)
			else:
				print 'Error!\nxxx: No search result'
				sys.exit(1)

		if child.name == 'item':
			flag = child
			child = child.children.next
			value.append(child.content)
			child = flag

		child = child.next

	return value

def parsingHTML(source):
	import re

	p = re.compile('http://.*mp3')
	voice = p.findall(source)

	if (len(voice) != 0):
		voice = voice[0]
	else:
		voice = ''

	p = re.compile('<div id="entryBody333" style="display: none;">((.|\n)*)<!-- //뜻풀이-->')
	source = p.split(source)

	p = re.compile('<br>', re.IGNORECASE)
	source = p.sub('\n', source[1])

	p = re.compile('&nbsp;')
	source = p.sub('', source)

	p = re.compile('<(/)?([a-zA-Z]*)(\\s[a-zA-Z]*=[^>]*)?(\\s)*(/)?>')
	source = p.sub('', source)	

	p = re.compile('<!--(([^-]*)|([-]{2})([^>]{1}))-->')
	source = p.sub('', source)

	p = re.compile('^\s\s+')
	source = p.sub('', source)

	source = voice + '\n' + source

	return source

if len(sys.argv) != 2:
	print 'Usage : ndic_sh word'
	sys.exit(1)

key = 'b01b9e7d6dda15d2be19197723184e6a'

url1 = 'http://openapi.naver.com/search?key='
url2 = '&query='
url3 = '&display=5&start=1&target=endic'

url = url1 + key + url2 + sys.argv[1] + url3

result = readHTMLSource(url)
result = parsingXMLSource(result)
print result[0]

for con in range(int(result[0])):
	content = readHTMLSource(result[con + 1], 'euc-kr')
	content = parsingHTML(content)
	print content
	print '출처 : naver.com (' + result[con + 1] + ')'
	if (con + 1 != int(result[0])):
		print '------------------------------'
