/*
 *  @Copyright (C) 2008 Kim Jin Chul (shriekout@gmail.com).
  *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
  *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
  *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#include <panel-applet.h>
#include <gst/gst.h>
#include <gtk/gtk.h>
#include "gdic_sh.h"
#include "callback.h"
#include "interface.h"
#include "support.h"

static const char Context_menu_xml[] =
	"<popup name=\"button3\">\n"
	"   <menuitem name=\"About Item\" "
	"             verb=\"About\" "
	"           _label=\"About...\"\n"
	"          pixtype=\"stock\" "
	"          pixname=\"gtk-about\"/>\n"
	"</popup>\n";

static const BonoboUIVerb menu_verbs[] = {
	BONOBO_UI_UNSAFE_VERB ("About", on_about_activate),
	BONOBO_UI_VERB_END
};

static gboolean gdic_sh_applet_fill(PanelApplet *applet,
											const gchar *iid,
											gpointer data)
{
	GtkWidget *hbox;

	gst_init(0, NULL);

	sound_head = NULL;

	panel_applet_setup_menu (applet,
                         Context_menu_xml,
                         menu_verbs,
                         (gpointer)applet);

	dic_w = create_dictionary_window("APPLET");
	hbox = create_applet_box(applet);
	gtk_container_add(GTK_CONTAINER(applet), hbox);

	gtk_widget_show_all(GTK_WIDGET(applet));

	return TRUE;
}

PANEL_APPLET_BONOBO_FACTORY("OAFIID:gdic_sh_Factory",
								PANEL_TYPE_APPLET,
								"gdic_sh Applet",
								VERSION,
								gdic_sh_applet_fill,
								NULL);
