/*
 *  @Copyright (C) 2008 Kim Jin Chul (shriekout@gmail.com).
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include <gtk/gtk.h>
#include <string.h>
#include <stdlib.h>
#include "gdic_sh.h"
#include "callback.h"
#include "support.h"

void read_content(char *word)
{
	FILE *po;
	char cmd[256];
	char buf[256];
	char buf2[256];
	char *buf3;
	GtkStatusbar *s;
	GtkTextTag *n_tag;
	GtkTextTag *w_tag;
	GtkTextTag *s_tag;
	GtkTextTag *o_tag;
	GtkTextTag *e_tag;
	GtkTextBuffer *buffer;
	GtkTextView *view;
	GtkTextIter start_iter;
	GtkTextIter end_iter;
	GtkWidget *event_box;
	GtkWidget *image;
	GtkTextChildAnchor *anchor;
	struct sound *cur, *new;
	int len;
	guint id;

	s = g_object_get_data(G_OBJECT(dic_w), "statusbar");
	id =  gtk_statusbar_get_context_id(s, "");
	gtk_statusbar_pop(s, id);
	gtk_statusbar_push(s, id, "단어 읽어오는 중...");

	cur = sound_head;

	while (sound_head != NULL) {
		sound_head = cur->next;
		free(cur->sd_url);
		gtk_widget_destroy(cur->widget);
		free(cur);
		cur = sound_head;
	}

	sound_head = NULL;

	sprintf(cmd, "%s %s", NDIC, word);

	if ((po = popen(cmd, "r")) != NULL) {
		buffer = g_object_get_data(G_OBJECT(dic_w), "content_buffer");
		view = g_object_get_data(G_OBJECT(dic_w), "content_view");

		w_tag = g_object_get_data(G_OBJECT(buffer), "word_tag");
		e_tag = g_object_get_data(G_OBJECT(buffer), "error_tag");
		n_tag = g_object_get_data(G_OBJECT(buffer), "normal_tag");
		s_tag = g_object_get_data(G_OBJECT(buffer), "sp_tag");
		o_tag = g_object_get_data(G_OBJECT(buffer), "origin_tag");

		gtk_text_buffer_get_start_iter(buffer, &start_iter);
		gtk_text_buffer_get_end_iter(buffer, &end_iter);
		gtk_text_buffer_delete(buffer, &start_iter, &end_iter);
		gtk_text_buffer_get_end_iter(buffer, &end_iter);

		fgets(buf, 255, po);

		if (!strcmp(buf, "Error!\n")) {
			gtk_text_buffer_insert_with_tags(buffer, &end_iter,
													buf, -1,
													e_tag,
													NULL);

			gtk_statusbar_pop(s, id);
			gtk_statusbar_push(s, id, "단어를 찾는데 이상이 발생했습니다.");
		} else {
			sprintf(buf2, "\t%s (%d)\n\n", word, atoi(buf));

			gtk_text_buffer_insert_with_tags(buffer, &end_iter,
													buf2, -1,
													w_tag,
													NULL);

			sprintf(buf2, "%d 개의 단어 뜻을 찾았습니다.", atoi(buf));
			gtk_statusbar_pop(s, id);
			gtk_statusbar_push(s, id, buf2);
		}

		while(fgets(buf, 255, po) != NULL) {
			gtk_text_buffer_get_end_iter(buffer, &end_iter);

			len = strlen(buf);
			strcpy(buf2, buf);
			buf2[len - 1] = '\0';
			buf3 = buf2 + (len - 5);

			if (!strcmp(buf3, ".mp3")) {
				event_box = gtk_event_box_new();
				image = gtk_image_new_from_file(SPEAKER_ICON);
				gtk_container_add(GTK_CONTAINER(event_box), image);
				gtk_widget_show(image);
				gtk_widget_show(event_box);

				anchor = gtk_text_buffer_create_child_anchor(buffer, &end_iter);
				gtk_text_view_add_child_at_anchor(view, event_box, anchor);

				gtk_text_buffer_get_end_iter(buffer, &end_iter);
				gtk_text_buffer_insert_with_tags(buffer, &end_iter,
														"\t", -1,
														n_tag,
														NULL);

				new = (struct sound *)malloc(sizeof(struct sound));
				new->sd_url = strdup(buf2);
				new->widget = event_box;
				new->next = NULL;

				if (sound_head == NULL) {
					sound_head = new;
					cur = sound_head;
				} else {
					cur->next = new;
					cur = new;
				}

				g_signal_connect(G_OBJECT(event_box), "button_press_event",
								G_CALLBACK(on_sound_event_box_button_press), (gpointer)cur->sd_url);
			} else if (!strcmp(buf2, "------------------------------")) {
				sprintf(buf2, "\n%s\n", buf);
				gtk_text_buffer_insert_with_tags(buffer, &end_iter,
														buf2, -1,
														s_tag,
														NULL);
			} else {
				buf2[6] = '\0';

				if (!strcmp(buf2, "출처")) {
					gtk_text_buffer_insert_with_tags(buffer, &end_iter,
															buf, -1,
															o_tag,
															NULL);
				} else {
					gtk_text_buffer_insert_with_tags(buffer, &end_iter,
															buf, -1,
															n_tag,
															NULL);
				}
			}
		}
	} else {
		printf("Error\n");

		return;
	}

	pclose(po);
}
